purescript-0.15.12: PureScript Programming Language Compiler

Safe Haskell | Safe-Inferred
Language | Haskell2010

Language.PureScript.Sugar.TypeClasses

Description

This module implements the desugaring pass which creates newtypes for type class dictionaries and value declarations for type class instances.

Synopsis

- desugarTypeClasses :: (MonadSupply m, MonadError MultipleErrors m) => [ExternsFile] -> Module -> m Module
- typeClassMemberName :: Declaration -> Text
- superClassDictionaryNames :: [Constraint a] -> [Text]

# Documentation

desugarTypeClasses :: (MonadSupply m, MonadError MultipleErrors m) => [ExternsFile] -> Module -> m Module #

Add type synonym declarations for type class dictionary types, and value declarations for type class instance dictionary expressions.

typeClassMemberName :: Declaration -> Text #

superClassDictionaryNames :: [Constraint a] -> [Text] #